//Define your action creators that will be responsible for asynchronous operations
import {CustomJoke} from "../../model/CustomJoke";
import {SampleJoke} from "../../model/SampleJoke";
import {setJokesList} from "../actions/JokeAction";

export const getLastSampleJokesList = () => {
    //In order to use await your callback must be asynchronous using async keyword.
    return async dispatch => {
        //Then perform your asynchronous operations.
        try {
            //Have it first fetch data from our starwars url.
            const jokesPromise = await fetch('https://iut-weather-api.azurewebsites.net/jokes/lasts');
            //Then use the json method to get json data from api/
            const jokesListJson = await jokesPromise.json();
            const jokesList: SampleJoke[] = jokesListJson.map(elt => new SampleJoke(elt["id"], elt["type"], elt["setup"], elt["image"]));
            dispatch(setJokesList(jokesList));
        } catch (error) {
            console.log('Error---------', error);
            //You can dispatch to another action if you want to display an error message in the application
            //dispatch(fetchDataRejected(error))
        }
    }
}